// Updates: 2004.09.27, 2003.10.18, 2002.01.08


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


/**
 * Use this class to test the Network class and the NetListener interface.
 * 
 * Exemple:
 * Computer 1 (Server): java TestNetwork
 * Computer 2 (Client): java TestNetwork ip_address_of_the_server
 *
 * Note: If you have only one computer you can test the program using the
 * following IP address: 127.0.0.1
 */      
public class TestNetwork extends JFrame implements ActionListener, NetListener {
  private Network network;
  private JTextArea ta;
  private JTextField tf;
   
  
  public TestNetwork() {
    super("Server");
    System.out.println("Server is waiting for the client...");
    network = new Network(45678);
    init();
    System.out.println("Server ready");
  }
  

  public TestNetwork(String address) {
    super("Client");
    network = new Network(address, 45678);
    init();
  }


  public static void main(String args[]) {
    if (args.length == 0) new TestNetwork(); // server
    else new TestNetwork(args[0]);           // client
  }
    
  
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(tf)) {
      network.send(tf.getText());
      tf.selectAll();              
    }
  }  
  
  
  public void messageArrived(Object inputMes) {
    if (inputMes == null) {
      network.close();
      System.exit(0);
    }
    ta.append((String)inputMes + "\n");
  }
  

  private void init() {
    network.addNetListener(this);
        
    JPanel p = new JPanel();
    p.setLayout(new BorderLayout());
    ta = new JTextArea();     
    ta.setEditable(false);
    ta.setForeground(Color.BLUE);
    ta.setMargin(new Insets(5, 5, 5, 5));     
    JScrollPane scrollPane = new JScrollPane(ta);
    p.add(scrollPane, BorderLayout.CENTER);
    tf = new JTextField();
    tf.addActionListener(this);
    p.add(tf, BorderLayout.SOUTH);
    getContentPane().add(p);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        network.close();
        System.exit(0);
      }
    });
    setSize(350, 350);
    setLocationRelativeTo(null);
    show();
    tf.requestFocus();
  }
} 